"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
/**
 * Store cookie strings in system keychain (via node-keytar when available)
 * or in filesystem.
 */
var fs = require("fs");
var path = require("path");
var util_1 = require("util");
var fileExists = util_1.promisify(fs.exists);
var mkdir = util_1.promisify(fs.mkdir);
var storage = {};
/** * Make sure the cookies folder exist.
 */
function prepareDirectory(directory) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fileExists(directory)];
                case 1:
                    if (!!(_a.sent())) return [3 /*break*/, 3];
                    return [4 /*yield*/, mkdir(directory)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3: return [2 /*return*/];
            }
        });
    });
}
try {
    // eslint-disable-next-line @typescript-eslint/no-var-requires
    var _a = require('keytar'), getPassword_1 = _a.getPassword, setPassword_1 = _a.setPassword;
    var SERVICE_1 = 'HttpProxySecureCookies';
    storage.get = function getCookies(account) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, getPassword_1(SERVICE_1, account)];
            });
        });
    };
    storage.set = function setCookies(account, secrets) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, setPassword_1(SERVICE_1, account, secrets)];
            });
        });
    };
}
catch (error) {
    var writeFile_1 = util_1.promisify(fs.writeFile);
    var readFile_1 = util_1.promisify(fs.readFile);
    var cookieDirectory_1 = path.join(process.cwd(), '.proxy-cookies');
    var getCookieFilePath_1 = function (account) {
        return path.join(cookieDirectory_1, account.replace(/[^a-z0-9\.\-]/gi, '_').toLowerCase() + ".txt");
    };
    storage.setCookieDirectory = function (directory) {
        cookieDirectory_1 = directory;
    };
    storage.get = function getCookies(account) {
        return __awaiter(this, void 0, void 0, function () {
            var cookieFile, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        cookieFile = getCookieFilePath_1(account);
                        return [4 /*yield*/, readFile_1(cookieFile, { encoding: 'utf-8' })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        error_1 = _a.sent();
                        return [2 /*return*/, null];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    storage.set = function setCookies(account, secrets) {
        return __awaiter(this, void 0, void 0, function () {
            var cookieFile;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, prepareDirectory(cookieDirectory_1)];
                    case 1:
                        _a.sent();
                        cookieFile = getCookieFilePath_1(account);
                        return [4 /*yield*/, writeFile_1(cookieFile, secrets, { encoding: 'utf-8' })];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
}
exports["default"] = storage;
